﻿
using System;
using System.Collections.Generic;
using Wisej.Web;

namespace Wisej.UserComboBoxDGVLookup
{
	public partial class Page2 : Page
	{
		BindingSource bsEmployee, bsEmployments;

		public Page2()
		{
			InitializeComponent();

			bsEmployee = new BindingSource();
			bsEmployee.DataSource = typeof(Employee);

			bsEmployments = new BindingSource();
			bsEmployments.DataSource = typeof(List<Employment>);

			Person person = new Person { FirstName = "Alex", LastName = "Prinias" };
			Company company1 = new Company { Name = "Wisej" };
			Company company2 = new Company { Name = "Icetea" };

			Employee employee = new Employee { Person = person };
			var employments = new List<Employment>();
			employments.Add(new Employment { Company = company1, Employee = employee }) ;
			employments.Add(new Employment { Company = company2, Employee = employee });

			txtFirst.DataBindings.Add(new Binding("Text", bsEmployee, "Person.FirstName"));
			txtLast.DataBindings.Add(new Binding("Text", bsEmployee, "Person.LastName"));
			txtFullFlat.DataBindings.Add(new Binding("Text", bsEmployee, "FullName"));

			txtCompanyFlat.DataBindings.Add(new Binding("Text", bsEmployments, "CompanyName"));
			txtEmployeeFlat.DataBindings.Add(new Binding("Text", bsEmployments, "EmployeeLastName"));
			txtCompanyNest.DataBindings.Add(new Binding("Text", bsEmployments, "Company.Name"));
			txtEmployeeNest.DataBindings.Add(new Binding("Text", bsEmployments, "Employee.Person.LastName"));

			bsEmployee.DataSource = employee;
			bsEmployments.DataSource = employments;

			drEmployments.DataSource = bsEmployments;
		}
    }

	public class Employee
    {
		public int NumEmployments { get; set; }
        public Person Person { get; set; }
        public string FullName { get => Person.FirstName + " " + Person.LastName; }
        public List<Employment> Employments { get; set; }
    }

	public class Person
    {
		public string FirstName { get; set; }
        public string LastName { get; set; }

    }

	public class Company
    {
		public string Name { get; set; }
    }

	public class Employment
    {
		public string CompanyName { get => Company.Name; }
        public string EmployeeLastName { get => Employee.Person.LastName; }
        public Company Company { get; set; }
        public Employee Employee { get; set; }
    }

}
